// REFRACTION SHADER

// UNTWEAKS
matrix WorldVP:WorldViewProjection;
matrix World:World;

// TWEAKS
float4 Colourvalue={1.0f,1.0f,1.0f,0.5f};
float U=1.0f;
float V=1.0f;
float4 LightPosition={1.0f,1.0f,1.0f,1.0f};

// TEXTURE
texture ScreenTX <string Name="";>;
sampler2D Screen=sampler_state{Texture=<ScreenTX>;ADDRESSU=CLAMP;ADDRESSV=CLAMP;ADDRESSW=CLAMP;};
texture NormalmapTX <string Name="";>;
sampler2D Normalmap=sampler_state{Texture=<NormalmapTX>;};

// STRUCTURES
struct input{float4 Pos:POSITION;float2 UV:TEXCOORD;float4 Norm:NORMAL;};
struct output{float4 OPos:POSITION;float2 Tex:TEXCOORD0;float4 posview:TEXCOORD1;float4 Col:COLOR0;};

// VERTEX SHADER
output VS(input IN){output OUT;OUT.OPos=mul(IN.Pos,WorldVP);OUT.Tex=IN.UV*float2(U,V);OUT.Col=dot(mul(float4(IN.Norm.xyz,0),World),LightPosition);OUT.Col=OUT.Col*0.05;float4x4 txtscale=float4x4(0.5,0,0,0.5,0,-0.5,0,0.5,0,0,0.5,0.5,0,0,0,1);OUT.posview=mul(txtscale,OUT.OPos);return OUT;}

// PIXEL SHADER
float4 PS(output IN):COLOR{float4 distort=tex2D(Normalmap,IN.Tex)*2-1;distort=normalize(distort);float2 nuv=IN.posview.xy/IN.posview.z+distort;float4 Refract=tex2D(Screen,nuv)*1.1;return Refract * Colourvalue * 0.8 + IN.Col;}

// TECHNIQUES
technique Distort{pass p1{VertexShader=compile vs_2_0 VS();PixelShader=compile ps_2_0 PS();}}
